import dds
import ddsutil
import struct

class Transform___TypeSupport(dds.TypeSupport):

    _typename = 'geometry_msgs::msg::dds_::Transform_'
    _keylist = ''
    _metadescriptor = '<MetaData version="1.0.0"><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="Vector3_"><Member name="x_"><Double/></Member><Member name="y_"><Double/></Member><Member name="z_"><Double/></Member></Struct><Struct name="Quaternion_"><Member name="x_"><Double/></Member><Member name="y_"><Double/></Member><Member name="z_"><Double/></Member><Member name="w_"><Double/></Member></Struct><Struct name="Transform_"><Member name="translation_"><Type name="Vector3_"/></Member><Member name="rotation_"><Type name="Quaternion_"/></Member></Struct></Module></Module></Module></MetaData>'

    def __init__(self):
        super(Transform___TypeSupport, self).__init__(self._typename,
              self._keylist,
              self._metadescriptor,
              struct.calcsize(Transform_()._get_packing_fmt()))

    def _serialize(self, o):
        if not isinstance(o, Transform_):
            raise TypeError('Incorrect data type')
        result = o._serialize()
        return result

    def _deserialize(self, buf):
        result = Transform_()
        data = struct.unpack(result._get_packing_fmt(), buf)
        result._deserialize(list(data))
        return result

class Transform_(ddsutil.TopicDataClass):

    @staticmethod
    def get_type_support():
        ''' Return type support information required for dds.Topic constructor '''
        return Transform___TypeSupport()

    @property
    def translation_(self):
        '''
        a DDS geometry_msgs::msg::dds_::Vector3_ value
        @rtype: Vector3_
        '''
        return self._translation__

    _translation__checker = ddsutil._class_checker(Vector3_)
    @translation_.setter
    def translation_(self, value):
        self._translation__checker(value)
        self._translation__ = value

    @property
    def rotation_(self):
        '''
        a DDS geometry_msgs::msg::dds_::Quaternion_ value
        @rtype: Quaternion_
        '''
        return self._rotation__

    _rotation__checker = ddsutil._class_checker(Quaternion_)
    @rotation_.setter
    def rotation_(self, value):
        self._rotation__checker(value)
        self._rotation__ = value

    _member_attributes = ('translation_', 'rotation_')

    def __init__(self, **kwargs):
        ''' Create a Transform_ instance, optionally initializing fields by name '''
        # init attributes to default value
        self.translation_ = Vector3_()
        self.rotation_ = Quaternion_()
        # set values for attributes passed in
        for key, value in kwargs.items():
            if key not in self._member_attributes:
                raise TypeError('Invalid argument name : %s' %(key))
            setattr(self, key, value)

    _packing_fmt = None

    @staticmethod
    def _get_packing_fmt():
        ''' Returns packing format of this class data '''
        if Transform_._packing_fmt is not None:
            return Transform_._packing_fmt
        fmt = ''
        fmt += ddsutil._align(fmt, Vector3_._get_packing_fmt())
        fmt += ddsutil._align(fmt, Quaternion_._get_packing_fmt())

        Transform_._packing_fmt = ddsutil._pad_fmt(fmt)
        return Transform_._packing_fmt

    def _serialize(self):
        ''' Serialize data for writing '''
        fmt = self._get_packing_fmt()
        args = self._get_packing_args()
        result = struct.pack(fmt, *args)
        return result

    def _deserialize(self, data):
        ''' Initialize values from data returned by struct.unpack()'''
        self.translation_ = Vector3_()._deserialize(data)
        self.rotation_ = Quaternion_()._deserialize(data)
        return self;

    def _get_packing_args(self):
        ''' Return an list of data suitable for struct.pack '''
        args = []
        args.extend(self.translation_._get_packing_args())
        args.extend(self.rotation_._get_packing_args())
        return args

